git-clone: split up long &&-command-chain and use a function for cleanup

Signed-off-by: Matthias Lederhofer <matled@gmx.net>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
This commit is contained in:
Matthias Lederhofer 2007-07-06 00:54:33 +02:00 committed by Junio C Hamano
parent 8960b5a7df
commit 68ad8910f7

View file

@ -187,15 +187,24 @@ dir="$2"
# Try using "humanish" part of source repo if user didn't specify one
[ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
[ -e "$dir" ] && die "destination directory '$dir' already exists."
mkdir -p "$dir" &&
D=$(cd "$dir" && pwd) &&
trap 'err=$?; cd ..; rm -rf "$D"; exit $err' 0
D=
cleanup() {
err=$?
test -z "$D" && rm -rf "$dir"
cd ..
test -n "$D" && rm -rf "$D"
exit $err
}
trap cleanup 0
mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
case "$bare" in
yes)
GIT_DIR="$D" ;;
*)
GIT_DIR="$D/.git" ;;
esac && export GIT_DIR && git init $quiet ${template+"$template"} || usage
esac &&
export GIT_DIR &&
git-init $quiet ${template+"$template"} || usage
if test -n "$reference"
then